/*		 ITI-FG  Kernel module free public release
 *
 *		       Copyright (C) 1996-99 GOM mbH.
 *	         Rebenring 33, 38106 Braunschweig, GERMANY
 *		            All rights reserved
 *
 *
 * $Id: itifgIntF.h,v 7.0 2000/10/25 09:07:57 cvs Exp $
 *
 */

#ifndef _ITIFGFUNC_H
#define _ITIFGFUNC_H

#if defined(linux) && defined(__KERNEL__) || \
    defined(__NetBSD__) && defined(_KERNEL) || \
    !defined(OS_DEFINED) || defined(__CONFIG__)

/* -- itifgReg.c -----------------------------------------------------------*/

/* read handler */

u_long
icr_get_mbox1 (itifg_t*);
u_long
icr_get_mbox2 (itifg_t*);
u_long
icr_get_mbox3 (itifg_t*);
u_long
icr_get_mbox4 (itifg_t*);
u_long
icr_get_bmdst (itifg_t*);
u_long
icr_get_bmxc (itifg_t*);
u_char
icr_get_inten (itifg_t*);
u_char
icr_get_binten (itifg_t*);
u_char
icr_get_intst (itifg_t*);
u_char
icr_get_bintst (itifg_t*);
u_char
icr_get_maint (itifg_t*);
u_char
icr_get_taint (itifg_t*);
u_char
icr_get_fifofl (itifg_t*);
u_char
icr_get_fifo4p (itifg_t*);
u_char
icr_get_fifoem (itifg_t*);
u_char
icr_get_bmdone (itifg_t*);
u_char
icr_get_bmreq (itifg_t*); /* IC-PCI Only! */

/* write handler */

int
icr_set_mbox1 (itifg_t*, u_long);
int
icr_set_mbox2 (itifg_t*, u_long);
int
icr_set_mbox3 (itifg_t*, u_long);
int
icr_set_mbox4 (itifg_t*, u_long);
int
icr_set_bmdst (itifg_t*, u_long); /* IC-PCI Only! */
int
icr_set_bmxc (itifg_t*, u_long); /* IC-PCI Only! */
int
icr_set_inten (itifg_t*, u_char);
int
icr_set_binten (itifg_t*, u_char);
int
icr_set_bmreq (itifg_t*, u_char); /* IC-PCI Only! */ 

/* clear handler */

int
icr_clear_fifoclr (itifg_t*);

/* init handler */

int
icr_init_intctl (itifg_t*);
int
icr_init_bmctl (itifg_t*);

/* special interrupt handler */ 

void xcr_test_irqs (itifg_t*, u_long*);
void xcr_clear_irqs (itifg_t*);

/* -- icpciReg.c ------------------------------------------------------------*/

/* read handler */
u_char cr_get_bmstren (itifg_t*);
u_char cr_get_bmilace (itifg_t*);
u_char cr_get_pixsz (itifg_t*);
u_char cr_get_memcfg (itifg_t*); 
u_char cr_get_vbstat (itifg_t*); 
u_char cr_get_fldstat (itifg_t*);
u_char cr_get_smstat (itifg_t*); 
u_char cr_get_amp (itifg_t*);
u_char cr_get_tmode (itifg_t*);
u_char cr_get_fcnt (itifg_t*);
u_char cr_get_fldsel (itifg_t*); 
u_char cr_get_acqmd (itifg_t*);
u_char cr_get_newaq (itifg_t*);
u_char cr_get_gstat (itifg_t*);
u_char cr_get_fstrt (itifg_t*);
u_short cr_get_pitch (itifg_t*); 
u_short cr_get_aoix (itifg_t*);
u_long cr_get_bmsf (itifg_t*);
u_long cr_get_bmss (itifg_t*);
u_long cr_get_aqstart (itifg_t*);
u_long cr_get_aqadr (itifg_t*); 
u_long cr_get_intadr (itifg_t*);
u_char cr_get_vbien (itifg_t*);
u_char cr_get_ovbien (itifg_t*); 
u_char cr_get_evbien (itifg_t*); 
u_char cr_get_amien (itifg_t*);
u_char cr_get_trigien (itifg_t*);
u_char cr_get_adrien (itifg_t*); 
u_char cr_get_aqien (itifg_t*);
u_char cr_get_vbint (itifg_t*);
u_char cr_get_ovbint (itifg_t*); 
u_char cr_get_evbint (itifg_t*); 
u_char cr_get_amint (itifg_t*);
u_char cr_get_trigint (itifg_t*);
u_char cr_get_adrint (itifg_t*); 
u_char cr_get_aqint (itifg_t*);
u_char cr_get_hdec (itifg_t*);	/* REV-B Only! */
u_char cr_get_vdec (itifg_t*);	/* REV-B Only! */
u_char cr_get_clip (itifg_t*);	/* REV-B Only! */
u_char cr_get_bmzoom (itifg_t*);	/* PCVision Only! */
u_char cr_get_outstrb (itifg_t*);	/* REV-B Only! */
u_char cr_get_inregenb (itifg_t*);	/* REV-B Only! */
u_char cr_get_instrbpol (itifg_t*);	/* REV-B Only! */
u_char cr_get_inregclr (itifg_t*);	/* REV-B Only! */
u_char cr_get_inpien (itifg_t*);	/* REV-B Only! */
u_char cr_get_inpintpol (itifg_t*);	/* REV-B Only! */
u_char cr_get_inpint (itifg_t*);	/* REV-B Only! */
u_char cr_get_inprint (itifg_t*);	/* REV-B Only! */
u_char cr_get_inprstrb (itifg_t*);	/* REV-B Only! */
u_char cr_get_pad16 (itifg_t*);		/* PCVision Only! */
u_char cr_get_outport (itifg_t*);	/* REV-B Only! */
u_char cr_get_inport (itifg_t*);	/* REV-B Only! */

/* write handler */
int cr_set_bmstren (itifg_t*, u_char);
int cr_set_bmilace (itifg_t*, u_char);
int cr_set_pixsz (itifg_t*, u_char);
int cr_set_memcfg (itifg_t*, u_char); 
int cr_set_tmode (itifg_t*, u_char);
int cr_set_fcnt (itifg_t*, u_char);
int cr_set_fldsel (itifg_t*, u_char);
int cr_set_acqmd (itifg_t*, u_char);
int cr_set_pitch (itifg_t*, u_short);
int cr_set_aoix (itifg_t*, u_short);
int cr_set_bmsf (itifg_t*, u_long);
int cr_set_bmss (itifg_t*, u_long);
int cr_set_aqstart (itifg_t*, u_long);
int cr_set_intadr (itifg_t*, u_long);
int cr_set_vbien (itifg_t*, u_char);
int cr_set_ovbien (itifg_t*, u_char);
int cr_set_evbien (itifg_t*, u_char);
int cr_set_amien (itifg_t*, u_char);
int cr_set_trigien (itifg_t*, u_char);
int cr_set_adrien (itifg_t*, u_char);
int cr_set_aqien (itifg_t*, u_char);
int cr_set_hdec (itifg_t*, u_char);	/* REV-B Only! */
int cr_set_vdec (itifg_t*, u_char);	/* REV-B Only! */
int cr_set_clip (itifg_t*, u_char);	/* REV-B Only! */
int cr_set_bmzoom (itifg_t*, u_char);	/* PCVision Only! */
int cr_set_outstrb (itifg_t*, u_char);	/* REV-B Only! */
int cr_set_inregenb (itifg_t*, u_char);	/* REV-B Only! */
int cr_set_instrbpol (itifg_t*, u_char);	/* REV-B Only! */
int cr_set_inregclr (itifg_t*, u_char);	/* REV-B Only! */
int cr_set_inpien (itifg_t*, u_char);	/* REV-B Only! */
int cr_set_inpintpol (itifg_t*, u_char);	/* REV-B Only! */
int cr_set_pad16 (itifg_t*, u_char);	/* PCVision Only! */
int cr_set_outport (itifg_t*, u_char);	/* REV-B Only! */

/* init handler */
int cr_init_con (itifg_t*);
int cr_init_acqcon (itifg_t*);
int cr_init_intcon (itifg_t*);
int cr_init_wzoom (itifg_t*);
int cr_init_mdata (itifg_t*);
int cr_init_portcon (itifg_t*);
int cr_init_outport (itifg_t*);

/* -- amvsReg.c -------------------------------------------------------------*/

/* read handler */

u_char vs_get_rev (itifg_t*);
u_char vs_get_tgid (itifg_t*);
u_char vs_get_tsel (itifg_t*);
u_char vs_get_clksrc (itifg_t*);
u_char vs_get_lpfsel (itifg_t*);
u_char vs_get_iscale (itifg_t*);
u_char vs_get_smode (itifg_t*);
u_char vs_get_camsel (itifg_t*);
u_char vs_get_tsrc (itifg_t*);
u_char vs_get_lenpol (itifg_t*);
u_char vs_get_fldpol (itifg_t*);
u_char vs_get_fenpol (itifg_t*);
u_char vs_get_pclkpol (itifg_t*);
u_char vs_get_eclken (itifg_t*);
u_char vs_get_vbstat (itifg_t*);
u_char vs_get_fldsten (itifg_t*);
u_char vs_get_vsten (itifg_t*);
u_char vs_get_trigen (itifg_t*);
u_char vs_get_trigsrc (itifg_t*);
u_char vs_get_fmode  (itifg_t*);
u_char vs_get_tmode (itifg_t*);
u_char vs_get_trigcy (itifg_t*);
u_char vs_get_strbdly (itifg_t*);
u_short vs_get_hoff (itifg_t*);
u_short vs_get_hsz (itifg_t*);
u_short vs_get_voff (itifg_t*);
u_short vs_get_vsz (itifg_t*);
u_short vs_get_froff (itifg_t*);
u_char vs_get_cppos (itifg_t*);
u_char vs_get_cpen (itifg_t*);
u_char vs_get_cpsrc (itifg_t*);
u_char vs_get_strbsel (itifg_t*);
u_char vs_get_strbpol (itifg_t*);
u_char vs_get_cpst (itifg_t*);
u_char vs_get_lutdata (itifg_t*, struct vs_lut_t*); 
u_short vs_get_nref (itifg_t*);
u_short vs_get_pref (itifg_t*);

/* write handler */

int vs_set_tsel (itifg_t*, u_char);
int vs_set_clksrc (itifg_t*, u_char);
int vs_set_lpfsel (itifg_t*, u_char);
int vs_set_iscale (itifg_t*, u_char);
int vs_set_smode (itifg_t*, u_char);
int vs_set_camsel (itifg_t*, u_char);
int vs_set_tsrc (itifg_t*, u_char);
int vs_set_lenpol (itifg_t*, u_char);
int vs_set_fldpol (itifg_t*, u_char);
int vs_set_fenpol (itifg_t*, u_char);
int vs_set_pclkpol (itifg_t*, u_char);
int vs_set_eclken (itifg_t*, u_char);
int vs_set_fldsten (itifg_t*, u_char);
int vs_set_vsten (itifg_t*, u_char);
int vs_set_trigen (itifg_t*, u_char);
int vs_set_trigsrc (itifg_t*, u_char);
int vs_set_fmode (itifg_t*, u_char);
int vs_set_tmode (itifg_t*, u_char);
int vs_set_strbdly (itifg_t*, u_char);
int vs_set_hoff (itifg_t*, u_short);
int vs_set_hsz (itifg_t*, u_short);
int vs_set_voff (itifg_t*, u_short);
int vs_set_vsz (itifg_t*, u_short);
int vs_set_froff (itifg_t*, u_short);
int vs_set_cppos (itifg_t*, u_char);
int vs_set_cpen (itifg_t*, u_char);
int vs_set_cpsrc (itifg_t*, u_char);
int vs_set_strbsel (itifg_t*, u_char);
int vs_set_strbpol (itifg_t*, u_char);
int vs_set_cpst (itifg_t*, u_char);
int vs_set_lutdata (itifg_t*, struct vs_lut_t*);
int vs_set_nref (itifg_t*, u_short);
int vs_set_pref (itifg_t*, u_short);

/* init handler */

int vs_init_con1 (itifg_t*);
int vs_init_con2 (itifg_t*);
int vs_init_trigcon (itifg_t*);
int vs_init_cpcon (itifg_t*);
int vs_init_adccon (itifg_t*);

/* misc handler */

int vs_sw_trig (itifg_t*);
int vs_lin_lut (itifg_t*);
void vs_dump_regs (itifg_t*);

/* -- amdigReg.c ------------------------------------------------------------*/

/* read handler */

u_char dg_get_rev (itifg_t*);   
u_char dg_get_modver (itifg_t*);
u_char dg_get_fsel (itifg_t*);  
u_char dg_get_clkdiv (itifg_t*);
u_char dg_get_xillen (itifg_t*);
u_char dg_get_mc (itifg_t*);    
u_char dg_get_pclkpol (itifg_t*);
u_char dg_get_lenpol (itifg_t*);
u_char dg_get_fenpol (itifg_t*);
u_char dg_get_fldpol (itifg_t*);
u_char dg_get_smode (itifg_t*); 
u_char dg_get_ilmode (itifg_t*);
u_char dg_get_lensm (itifg_t*); 
u_char dg_get_nolmiss (itifg_t*);
u_char dg_get_lvar (itifg_t*);  
u_char dg_get_exclk (itifg_t*); 
u_char dg_get_extmd (itifg_t*); 
u_char dg_get_exsen (itifg_t*); 
u_char dg_get_exspol (itifg_t*); 
u_char dg_get_prien  (itifg_t*);
u_char dg_get_prip (itifg_t*);  
u_short dg_get_extime (itifg_t*);
u_char dg_get_psize (itifg_t*); 
u_char dg_get_ilpixel (itifg_t*);
u_char dg_get_muxa (itifg_t*);  
u_char dg_get_muxb (itifg_t*);  
u_char dg_get_muxc (itifg_t*);  
u_char dg_get_lutpg (itifg_t*); 
u_char dg_get_olutpg (itifg_t*);
u_short dg_get_hoff (itifg_t*); 
u_short dg_get_hact (itifg_t*); 
u_short dg_get_voff (itifg_t*); 
u_short dg_get_vact (itifg_t*); 
u_char dg_get_trigen (itifg_t*);
u_char dg_get_trigsrc (itifg_t*);
u_char dg_get_trigcy (itifg_t*);
u_char dg_get_vb (itifg_t*);    
u_char dg_get_fld (itifg_t*);   
u_short dg_get_lstat (itifg_t*);
#define dg_get_lut16 iti_get_lut16
u_char dg_get_lut8 (itifg_t*, struct dg_lut8_t*);

/* write handler */

int dg_set_fsel (itifg_t*, u_char);  
int dg_set_clkdiv (itifg_t*, u_char);
int dg_set_xillen (itifg_t*, u_char);
int dg_set_mc (itifg_t*, u_char);    
int dg_set_pclkpol (itifg_t*, u_char);
int dg_set_lenpol (itifg_t*, u_char);
int dg_set_fenpol (itifg_t*, u_char);
int dg_set_fldpol (itifg_t*, u_char);
int dg_set_smode (itifg_t*, u_char); 
int dg_set_ilmode (itifg_t*, u_char);
int dg_set_lensm (itifg_t*, u_char); 
int dg_set_nolmiss (itifg_t*, u_char);
int dg_set_lvar (itifg_t*, u_char);  
int dg_set_exclk (itifg_t*, u_char); 
int dg_set_extmd (itifg_t*, u_char); 
int dg_set_exsen (itifg_t*, u_char); 
int dg_set_exspol (itifg_t*, u_char); 
int dg_set_prien  (itifg_t*, u_char);
int dg_set_prip (itifg_t*, u_char);  
int dg_set_extime (itifg_t*, u_short);
int dg_set_psize (itifg_t*, u_char); 
int dg_set_ilpixel (itifg_t*, u_char);
int dg_set_muxa (itifg_t*, u_char);  
int dg_set_muxb (itifg_t*, u_char);  
int dg_set_muxc (itifg_t*, u_char);  
int dg_set_lutpg (itifg_t*, u_char); 
int dg_set_olutpg (itifg_t*, u_char);
int dg_set_hoff (itifg_t*, u_short); 
int dg_set_hact (itifg_t*, u_short); 
int dg_set_voff (itifg_t*, u_short); 
int dg_set_vact (itifg_t*, u_short); 
int dg_set_trigen (itifg_t*, u_char);
int dg_set_trigsrc (itifg_t*, u_char);
#define dg_set_lut16 iti_set_lut16
int dg_set_lut8 (itifg_t*, struct dg_lut8_t*);

/* init handler */

int dg_init_clkcon (itifg_t*);
int dg_init_ctcon (itifg_t*);
int dg_init_excon (itifg_t*);
int dg_init_lutcon (itifg_t*);
int dg_init_lutsel (itifg_t*);
int dg_init_trigcon (itifg_t*);

/* misc handler */

int dg_sw_trig (itifg_t*);
int dg_lin_lut8 (itifg_t*);
#define dg_lin_lut16 iti_lin_lut16
void dg_dump_regs (itifg_t*);

/* -- ampvReg.c -------------------------------------------------------------*/

/* read handler */

u_char
pv_get_rev (itifg_t*);
u_char
pv_get_lutdata (itifg_t*, struct pv_lut_t*); 
u_char
pv_get_nref (itifg_t*);
u_char
pv_get_pref (itifg_t*);
u_short
pv_get_htotal (itifg_t*);
u_char
pv_get_hsyncpw (itifg_t*);
u_char
pv_get_hequipw (itifg_t*);
u_short
pv_get_hserrpw (itifg_t*);
u_short
pv_get_vtotal (itifg_t*);
u_char
pv_get_vsyncpw (itifg_t*);
u_char
pv_get_hsyncpol (itifg_t*);
u_char
pv_get_vsyncpol (itifg_t*);
u_short
pv_get_vgstart (itifg_t*);
u_char
pv_get_vgwidth (itifg_t*);
u_short
pv_get_hoffset (itifg_t*);
u_short
pv_get_hactive (itifg_t*);
u_short
pv_get_voffset (itifg_t*);
u_short
pv_get_vactive  (itifg_t*);
u_char
pv_get_strbdly (itifg_t*);
u_char
pv_get_lenpol (itifg_t*);	/* REV-B Only! */
u_char
pv_get_fenpol (itifg_t*);	/* REV-B Only! */
u_char
pv_get_froff (itifg_t*);
u_char
pv_get_frstonv (itifg_t*);
u_char
pv_get_frstmd (itifg_t*);
u_char
pv_get_frstpol (itifg_t*);
u_char
pv_get_frstsz (itifg_t*);
u_char
pv_get_syncsel (itifg_t*);
u_char
pv_get_chsyncen (itifg_t*);
u_char
pv_get_vsyncen (itifg_t*);
u_char
pv_get_clksrc (itifg_t*);
u_char
pv_get_lpfsel (itifg_t*);
u_char
pv_get_vscan (itifg_t*);	/* REV-B Only! */
u_char
pv_get_iscale (itifg_t*);
u_char
pv_get_vclkpol (itifg_t*);	/* REV-B Only! */
u_char
pv_get_smode (itifg_t*);
u_char
pv_get_camsel (itifg_t*);
u_char
pv_get_fldshft (itifg_t*);
u_char
pv_get_einpol (itifg_t*);
u_char
pv_get_ein0ien (itifg_t*);
u_char
pv_get_ein1ien (itifg_t*);
u_char
pv_get_ein0 (itifg_t*);
u_char
pv_get_ein1 (itifg_t*);
u_char
pv_get_eout0 (itifg_t*);
u_char
pv_get_eout1 (itifg_t*);
u_char
pv_get_sotint (itifg_t*);
u_char
pv_get_eotint (itifg_t*);
u_char
pv_get_ein0int (itifg_t*);
u_char
pv_get_ein1int (itifg_t*);
u_char
pv_get_trigen (itifg_t*);
u_char
pv_get_trigcy (itifg_t*);
u_char
pv_get_sotien (itifg_t*);
u_char
pv_get_eotien (itifg_t*);
u_char
pv_get_trigsrc (itifg_t*);
u_char
pv_get_trigpol (itifg_t*);
u_char
pv_get_strbmd (itifg_t*);
u_char
pv_get_strben (itifg_t*);	/* REV-B Only! */
u_char
pv_get_strbpol (itifg_t*);
u_char
pv_get_skpfldmd (itifg_t*);
u_char
pv_get_ccnt (itifg_t*);
u_char
pv_get_pclmpol (itifg_t*);
u_char
pv_get_clmpsrc (itifg_t*);
u_short
pv_get_fdiv (itifg_t*);
u_short
pv_get_rdiv (itifg_t*);
u_char
pv_get_vcogain (itifg_t*);
u_char
pv_get_pda (itifg_t*);
u_char
pv_get_lcnt (itifg_t*);

/* write handler */

int
pv_set_lutdata (itifg_t*, struct pv_lut_t*); 
int
pv_set_nref (itifg_t*, u_char);
int
pv_set_pref (itifg_t*, u_char);
int
pv_set_htotal (itifg_t*, u_short);
int
pv_set_hsyncpw (itifg_t*, u_char);
int
pv_set_hequipw (itifg_t*, u_char);
int
pv_set_hserrpw (itifg_t*, u_short);
int
pv_set_vtotal (itifg_t*, u_short);
int
pv_set_vsyncpw (itifg_t*, u_char);
int
pv_set_hsyncpol (itifg_t*, u_char);
int
pv_set_vsyncpol (itifg_t*, u_char);
int
pv_set_vgstart (itifg_t*, u_short);
int
pv_set_vgwidth (itifg_t*, u_char);
int
pv_set_hoffset (itifg_t*, u_short);
int
pv_set_hactive (itifg_t*, u_short);
int
pv_set_voffset (itifg_t*, u_short);
int
pv_set_vactive  (itifg_t*, u_short);
int
pv_set_strbdly (itifg_t*, u_char);
int
pv_set_lenpol (itifg_t*, u_char);	/* REV-B Only! */
int
pv_set_fenpol (itifg_t*, u_char);	/* REV-B Only! */
int
pv_set_froff (itifg_t*, u_char);
int
pv_set_frstonv (itifg_t*, u_char);
int
pv_set_frstmd (itifg_t*, u_char);
int
pv_set_frstpol (itifg_t*, u_char);
int
pv_set_frstsz (itifg_t*, u_char);
int
pv_set_syncsel (itifg_t*, u_char);
int
pv_set_chsyncen (itifg_t*, u_char);
int
pv_set_vsyncen (itifg_t*, u_char);
int
pv_set_clksrc (itifg_t*, u_char);
int
pv_set_lpfsel (itifg_t*, u_char);
int
pv_set_vscan (itifg_t*, u_char);	/* REV-B Only! */
int
pv_set_iscale (itifg_t*, u_char);
int
pv_set_vclkpol (itifg_t*, u_char);	/* REV-B Only! */
int
pv_set_smode (itifg_t*, u_char);
int
pv_set_camsel (itifg_t*, u_char);
int
pv_set_fldshft (itifg_t*, u_char);
int
pv_set_einpol (itifg_t*, u_char);
int
pv_set_ein0ien (itifg_t*, u_char);
int
pv_set_ein1ien (itifg_t*, u_char);
int
pv_set_eout0 (itifg_t*, u_char);
int
pv_set_eout1 (itifg_t*, u_char);
int
pv_set_trigen (itifg_t*, u_char);
int
pv_set_sotien (itifg_t*, u_char);
int
pv_set_eotien (itifg_t*, u_char);
int
pv_set_trigsrc (itifg_t*, u_char);
int
pv_set_trigpol (itifg_t*, u_char);
int
pv_set_strbmd (itifg_t*, u_char);
int
pv_set_strben (itifg_t*, u_char);	/* REV-B Only! */
int
pv_set_strbpol (itifg_t*, u_char);
int
pv_set_skpfldmd (itifg_t*, u_char);
int
pv_set_ccnt (itifg_t*, u_char);
int
pv_set_pclmpol (itifg_t*, u_char);
int
pv_set_clmpsrc (itifg_t*, u_char);
int
pv_set_fdiv (itifg_t*, u_short);
int
pv_set_rdiv (itifg_t*, u_short);
int
pv_set_vcogain (itifg_t*, u_char);
int
pv_set_pda (itifg_t*, u_char);
int
pv_set_lcnt (itifg_t*, u_char);

/* init handler */

int
pv_init_adccon (itifg_t*);
int
pv_init_vsyncpw (itifg_t*);
int
pv_init_strbdly (itifg_t*);
int
pv_init_frstdly (itifg_t*);
int
pv_init_con1 (itifg_t*);
int
pv_init_con2 (itifg_t*);
int
pv_init_trigcon (itifg_t*);
int
pv_init_p_clamp (itifg_t*);
int
pv_init_pllregs (itifg_t*);

/* misc handler */

int
pv_sw_trig (itifg_t*);
int
pv_lin_lut (itifg_t*);
void
pv_dump_regs (itifg_t*);

/* -- pcdigReg.c ------------------------------------------------------------*/

/* read handler */
u_char
pcd_get_bmenb (itifg_t*);
u_char
pcd_get_bmstep (itifg_t*);
u_char
pcd_get_octacc (itifg_t*);
u_char
pcd_get_dmaacc (itifg_t*);
u_long
pcd_get_aqstart (itifg_t*);
u_long
pcd_get_aqadr (itifg_t*);
u_long
pcd_get_intadr (itifg_t*);
u_char
pcd_get_octswap (itifg_t*);
u_char
pcd_get_pad (itifg_t*);
u_char
pcd_get_clip (itifg_t*);
u_long
pcd_get_segsize (itifg_t*);
u_short
pcd_get_octstart (itifg_t*);
u_long
pcd_get_swcount (itifg_t*);
u_char
pcd_get_adrien (itifg_t*);
u_char
pcd_get_bmien (itifg_t*);
u_char
pcd_get_swctien (itifg_t*);
u_char
pcd_get_adrint (itifg_t*);
u_char
pcd_get_bmint (itifg_t*);
u_char
pcd_get_swctint (itifg_t*);
u_char
pcd_get_lenenb (itifg_t*);
u_char
pcd_get_lensync (itifg_t*);
u_char
pcd_get_lenpol (itifg_t*);
u_char
pcd_get_fenenb (itifg_t*);
u_char
pcd_get_fenpol (itifg_t*);
u_char
pcd_get_multenb (itifg_t*);
u_char
pcd_get_multpol (itifg_t*);
u_char
pcd_get_multmd (itifg_t*);
u_char
pcd_get_pclkpol (itifg_t*);
u_char
pcd_get_driveext (itifg_t*);
u_char
pcd_get_useext (itifg_t*);
u_char
pcd_get_restime (itifg_t*);
u_char
pcd_get_respol (itifg_t*);
u_char
pcd_get_cam3enb (itifg_t*);
u_char
pcd_get_exsenb (itifg_t*);
u_char
pcd_get_exspol (itifg_t*);
u_char
pcd_get_exsmd (itifg_t*);
u_char
pcd_get_prienb (itifg_t*);
u_char
pcd_get_pripol (itifg_t*);
u_char
pcd_get_cammd (itifg_t*);
u_char
pcd_get_cclkenb (itifg_t*);
u_char
pcd_get_cclkpol (itifg_t*);
u_char
pcd_get_exsclk (itifg_t*);
u_char
pcd_get_exssel (itifg_t*);
u_char
pcd_get_prisel (itifg_t*);
u_short
pcd_get_emidpnt (itifg_t*);
u_char
pcd_get_prihold (itifg_t*);
u_long
pcd_get_exstime (itifg_t*);
u_char
pcd_get_stmode (itifg_t*);
u_char
pcd_get_etmode (itifg_t*);
u_char
pcd_get_acqmd (itifg_t*);
u_char
pcd_get_fldsel (itifg_t*);
u_char
pcd_get_fcnt (itifg_t*);
u_char
pcd_get_newaq (itifg_t*);
u_char
pcd_get_gstat (itifg_t*);
u_char
pcd_get_fstrt (itifg_t*);
u_short
pcd_get_hoff (itifg_t*);
u_long
pcd_get_hact (itifg_t*);
u_short
pcd_get_voff (itifg_t*);
u_long
pcd_get_vact (itifg_t*);
u_char
pcd_get_synmuxa (itifg_t*);
u_char
pcd_get_synmuxb (itifg_t*);
u_short
pcd_get_lvact (itifg_t*);
int
pcd_get_lut0psz (itifg_t*);
u_char
pcd_get_lutacc (itifg_t*);
u_char
pcd_get_lut0pg (itifg_t*);
int
pcd_get_lut1psz (itifg_t*);
u_char
pcd_get_lut1pg (itifg_t*);
u_char
pcd_get_trig0pol (itifg_t*);
u_char
pcd_get_trig0src (itifg_t*);
u_char
pcd_get_trig0gd (itifg_t*);
u_char
pcd_get_trig1pol (itifg_t*);
u_char
pcd_get_trig1src (itifg_t*);
u_char
pcd_get_trig1gd (itifg_t*);
u_char
pcd_get_trig0diff (itifg_t*);
u_char
pcd_get_trig0ttl (itifg_t*);
u_char
pcd_get_trig0opto (itifg_t*);
u_char
pcd_get_trig0cyc (itifg_t*);
u_char
pcd_get_trig1diff (itifg_t*);
u_char
pcd_get_trig1ttl (itifg_t*);
u_char
pcd_get_trig1opto (itifg_t*);
u_char
pcd_get_trig1cyc (itifg_t*);
u_char
pcd_get_camlen (itifg_t*);
u_char
pcd_get_camfen (itifg_t*);
u_char
pcd_get_cammult (itifg_t*);
u_char
pcd_get_vbien (itifg_t*);
u_char
pcd_get_hbien (itifg_t*);
u_char
pcd_get_trig0ien (itifg_t*);
u_char
pcd_get_trig1ien (itifg_t*);
u_char
pcd_get_vbien (itifg_t*);
u_char
pcd_get_hbien (itifg_t*);
u_char
pcd_get_trig0ien (itifg_t*);
u_char
pcd_get_trig1ien (itifg_t*);
u_char
pcd_get_soaqien (itifg_t*);
u_char
pcd_get_eoaqien (itifg_t*);
u_char
pcd_get_pioien (itifg_t*);
u_char
pcd_get_vbint (itifg_t*);
u_char
pcd_get_hbint (itifg_t*);
u_char
pcd_get_trig0int (itifg_t*);
u_char
pcd_get_trig1int (itifg_t*);
u_char
pcd_get_vbint (itifg_t*);
u_char
pcd_get_hbint (itifg_t*);
u_char
pcd_get_trig0int (itifg_t*);
u_char
pcd_get_trig1int (itifg_t*);
u_char
pcd_get_soaqint (itifg_t*);
u_char
pcd_get_eoaqint (itifg_t*);
u_char
pcd_get_pioint (itifg_t*);
u_char
pcd_get_trigcnt (itifg_t*);
u_short
pcd_get_trigdiv (itifg_t*);
u_short
pcd_get_divcon (itifg_t*);
u_short
pcd_get_pvact (itifg_t*);
u_short
pcd_get_pmidpnt (itifg_t*);
u_char
pcd_get_hdec (itifg_t*);
u_char
pcd_get_vdec (itifg_t*);
u_char
pcd_get_sform (itifg_t*);
u_char
pcd_get_outstrb (itifg_t*);
u_char
pcd_get_inregenb (itifg_t*);
u_char
pcd_get_instrbpol (itifg_t*);
u_char
pcd_get_inregclr (itifg_t*);
u_char
pcd_get_inpintpol (itifg_t*);
u_char
pcd_get_inprint (itifg_t*);
u_char
pcd_get_inprstrb (itifg_t*);
u_char
pcd_get_outport (itifg_t*);
u_char
pcd_get_inport (itifg_t*);
u_char
pcd_get_fpgaprg (itifg_t*);
u_char
pcd_get_fpgardy (itifg_t*);
u_char
pcd_get_fpgadone (itifg_t*);
u_char
pcd_get_brdid (itifg_t*);

/* write handler */
int
pcd_set_bmenb (itifg_t*, u_char);
int
pcd_set_bmstep (itifg_t*, u_char);
int
pcd_set_octacc (itifg_t*, u_char);
int
pcd_set_dmaacc (itifg_t*, u_char);
int
pcd_set_aqstart (itifg_t*, u_long);
int
pcd_set_aqadr (itifg_t*, u_long);
int
pcd_set_intadr (itifg_t*, u_long);
int
pcd_set_octswap (itifg_t*, u_char);
int
pcd_set_pad (itifg_t*, u_char);
int
pcd_set_clip (itifg_t*, u_char);
int
pcd_set_segsize (itifg_t*, u_short);
int
pcd_set_octstart (itifg_t*, u_short);
int
pcd_set_swcount (itifg_t*, u_long);
int
pcd_set_adrien (itifg_t*, u_char);
int
pcd_set_bmien (itifg_t*, u_char);
int
pcd_set_swctien (itifg_t*, u_char);
int
pcd_set_adrint (itifg_t*, u_char);
int
pcd_set_bmint (itifg_t*, u_char);
int
pcd_set_swctint (itifg_t*, u_char);
int
pcd_set_lenenb (itifg_t*, u_char);
int
pcd_set_lensync (itifg_t*, u_char);
int
pcd_set_lenpol (itifg_t*, u_char);
int
pcd_set_fenenb (itifg_t*, u_char);
int
pcd_set_fenpol (itifg_t*, u_char);
int
pcd_set_multenb (itifg_t*, u_char);
int
pcd_set_multpol (itifg_t*, u_char);
int
pcd_set_multmd (itifg_t*, u_char);
int
pcd_set_pclkpol (itifg_t*, u_char);
int
pcd_set_driveext (itifg_t*, u_char);
int
pcd_set_useext (itifg_t*, u_char);
int
pcd_set_restime (itifg_t*, u_char);
int
pcd_set_respol (itifg_t*, u_char);
int
pcd_set_cam3enb (itifg_t*, u_char);
int
pcd_set_exsenb (itifg_t*, u_char);
int
pcd_set_exspol (itifg_t*, u_char);
int
pcd_set_exsmd (itifg_t*, u_char);
int
pcd_set_prienb (itifg_t*, u_char);
int
pcd_set_pripol (itifg_t*, u_char);
int
pcd_set_cammd (itifg_t*, u_char);
int
pcd_set_cclkenb (itifg_t*, u_char);
int
pcd_set_cclkpol (itifg_t*, u_char);
int
pcd_set_exsclk (itifg_t*, u_char);
int
pcd_set_exssel (itifg_t*, u_char);
int
pcd_set_prisel (itifg_t*, u_char);
int
pcd_set_emidpnt (itifg_t*, u_short);
int
pcd_set_prihold (itifg_t*, u_char);
int
pcd_set_exstime (itifg_t*, u_long);
int
pcd_set_stmode (itifg_t*, u_char);
int
pcd_set_etmode (itifg_t*, u_char);
int
pcd_set_acqmd (itifg_t*, u_char);
int
pcd_set_fldsel (itifg_t*, u_char);
int
pcd_set_fcnt (itifg_t*, u_char);
int
pcd_set_newaq (itifg_t*, u_char);
int
pcd_set_gstat (itifg_t*, u_char);
int
pcd_set_fstrt (itifg_t*, u_char);
int
pcd_set_hoff (itifg_t*, u_short);
int
pcd_set_hact (itifg_t*, u_long);
int
pcd_set_voff (itifg_t*, u_short);
int
pcd_set_vact (itifg_t*, u_long);
int
pcd_set_synmuxa (itifg_t*, u_char);
int
pcd_set_synmuxb (itifg_t*, u_char);
int
pcd_set_lut0psz (itifg_t*, u_char);
int
pcd_set_lutacc (itifg_t*, u_char);
int
pcd_set_lut0pg (itifg_t*, u_char);
int
pcd_set_lut1psz (itifg_t*, u_char);
int
pcd_set_lut1pg (itifg_t*, u_char);
int
pcd_set_trig0pol (itifg_t*, u_char);
int
pcd_set_trig0src (itifg_t*, u_char);
int
pcd_set_trig0gd (itifg_t*, u_char);
int
pcd_set_trig1pol (itifg_t*, u_char);
int
pcd_set_trig1src (itifg_t*, u_char);
int
pcd_set_trig1gd (itifg_t*, u_char);
int
pcd_set_vbien (itifg_t*, u_char);
int
pcd_set_hbien (itifg_t*, u_char);
int
pcd_set_trig0ien (itifg_t*, u_char);
int
pcd_set_trig1ien (itifg_t*, u_char);
int
pcd_set_vbien (itifg_t*, u_char);
int
pcd_set_hbien (itifg_t*, u_char);
int
pcd_set_trig0ien (itifg_t*, u_char);
int
pcd_set_trig1ien (itifg_t*, u_char);
int
pcd_set_soaqien (itifg_t*, u_char);
int
pcd_set_eoaqien (itifg_t*, u_char);
int
pcd_set_pioien (itifg_t*, u_char);
int
pcd_set_vbint (itifg_t*, u_char);
int
pcd_set_hbint (itifg_t*, u_char);
int
pcd_set_trig0int (itifg_t*, u_char);
int
pcd_set_trig1int (itifg_t*, u_char);
int
pcd_set_vbint (itifg_t*, u_char);
int
pcd_set_hbint (itifg_t*, u_char);
int
pcd_set_trig0int (itifg_t*, u_char);
int
pcd_set_trig1int (itifg_t*, u_char);
int
pcd_set_soaqint (itifg_t*, u_char);
int
pcd_set_eoaqint (itifg_t*, u_char);
int
pcd_set_pioint (itifg_t*, u_char);
int
pcd_set_trigcnt (itifg_t*, u_char);
int
pcd_set_trigdiv (itifg_t*, u_short);
int
pcd_set_divcon (itifg_t*, u_short);
int
pcd_set_pmidpnt (itifg_t*, u_short);
int
pcd_set_hdec (itifg_t*, u_char);
int
pcd_set_vdec (itifg_t*, u_char);
int
pcd_set_sform (itifg_t*, u_char);
int
pcd_set_outstrb (itifg_t*, u_char);
int
pcd_set_inregenb (itifg_t*, u_char);
int
pcd_set_instrbpol (itifg_t*, u_char);
int
pcd_set_inregclr (itifg_t*, u_char);
int
pcd_set_inpintpol (itifg_t*, u_char);
int
pcd_set_inprint (itifg_t*, u_char);
int
pcd_set_inprstrb (itifg_t*, u_char);
int
pcd_set_outport (itifg_t*, u_char);
int
pcd_set_inport (itifg_t*, u_char);
int
pcd_set_fpgaprg (itifg_t*, u_char);
int
pcd_set_fpgadata (itifg_t*, u_char);

/* clear handler */

/* init handler */

int
pcd_init_bmcon (itifg_t*);
int
pcd_init_bmlut (itifg_t*);
int
pcd_init_sginit (itifg_t*);
int
pcd_init_segsize (itifg_t*);
int
pcd_init_octstart (itifg_t*);
int
pcd_init_zoom (itifg_t*);
int
pcd_init_intcon1 (itifg_t*);
int
pcd_init_acqcon (itifg_t*);
int
pcd_init_fifoinit (itifg_t*);
int
pcd_init_intcon0 (itifg_t*);
int
pcd_init_decim (itifg_t*);
int
pcd_init_portcon (itifg_t*);
  
int
pcd_init_ctcon (itifg_t*);
int
pcd_init_outcon (itifg_t*);
int
pcd_init_exscon (itifg_t*);
int
pcd_init_cclkcon (itifg_t*);
int
pcd_init_lutcon0 (itifg_t*);
int
pcd_init_lutcon1 (itifg_t*);
int
pcd_init_trigcon (itifg_t*);
int
pcd_init_trigdiv (itifg_t*);

/* misc handler */
u_char
pcd_get_pixsz (itifg_t*);
int
pcd_sw_trig0 (itifg_t*);
int
pcd_sw_trig1 (itifg_t*);

#define pcd_get_lut	iti_get_lut16
#define pcd_set_lut	iti_set_lut16
#define pcd_lin_lut	iti_lin_lut16

void
pcd_dump_regs (itifg_t*);
int
pcd_load_fpga (itifg_t*, caddr_t);
int
pcd_calc_clkval (itifg_t*, double, u_long*);
int
pcd_write_clkval (itifg_t*, char, u_long);

u_char
pcd_get_fldstat (itifg_t*);
u_char
pcd_get_vbstat (itifg_t*);
u_char
pcd_get_smstat (itifg_t*);
u_char
pcd_get_tmode (itifg_t*);
int
pcd_set_tmode (itifg_t*, u_char);
int
pcd_update_exsync (itifg_t*);

#endif /* linux && __KERNEL__ || !OS_DEFINED || __CONFIG__ */

#endif /* _ITIFGFUNC_H */

